"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Table = exports.ifNotExists = void 0;
var client_dynamodb_1 = require("@aws-sdk/client-dynamodb");
var dynamodb_expressions_1 = require("@awslabs-community-fork/dynamodb-expressions");
var conditions_1 = require("./conditions");
var marshalling_1 = require("./marshalling");
var IfNotExistsKey = Symbol('IF_NOT_EXISTS');
var ifNotExists = function (o) {
    var _a;
    return (_a = {
            ifNotExists: o
        },
        _a[IfNotExistsKey] = true,
        _a);
};
exports.ifNotExists = ifNotExists;
var extractKey = function (obj, hk, rk) {
    var _a, _b;
    return Object.assign({}, (_a = {}, _a[hk] = obj[hk], _a), rk && (_b = {}, _b[rk] = obj[rk], _b));
};
var serializeSetAction = function (r, path, ue) {
    if (path === void 0) { path = []; }
    if (ue === void 0) { ue = new dynamodb_expressions_1.UpdateExpression(); }
    return Object.keys(r).reduce(function (p, n) {
        var toSet = r[n];
        if (toSet === null || toSet === void 0 ? void 0 : toSet.ifNotExists) {
            var attPath = new dynamodb_expressions_1.AttributePath(__spreadArray(__spreadArray([], __read(path), false), [
                { type: 'AttributeName', name: n },
            ], false));
            p.set(attPath, new dynamodb_expressions_1.FunctionExpression('if_not_exists', attPath, toSet.ifNotExists));
        }
        else if (!Array.isArray(toSet) && typeof toSet === 'object') {
            serializeSetAction(
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            toSet, __spreadArray(__spreadArray([], __read(path), false), [{ type: 'AttributeName', name: n }], false), ue);
        }
        else {
            toSet
                ? p.set(new dynamodb_expressions_1.AttributePath(__spreadArray(__spreadArray([], __read(path), false), [
                    { type: 'AttributeName', name: n },
                ], false)), toSet)
                : p.remove(new dynamodb_expressions_1.AttributePath(__spreadArray(__spreadArray([], __read(path), false), [
                    { type: 'AttributeName', name: n },
                ], false)));
        }
        return p;
    }, ue);
};
/* eslint-disable  @typescript-eslint/no-explicit-any */
var query = function (dynamo, logger, table, hk, rk, marshaller, indexName) { return function (hkv, opts) {
    var _a, _b, _c;
    var _d;
    var attributes = new dynamodb_expressions_1.ExpressionAttributes();
    var keyExpression = "".concat(attributes.addName(hk), " = ").concat(attributes.addValue(hkv)).concat((opts === null || opts === void 0 ? void 0 : opts.sortKeyExpression)
        ? " and ".concat((0, conditions_1.serializeConditionExpression)((_a = {},
            _a[rk] = opts.sortKeyExpression,
            _a), attributes))
        : '');
    var lastKey = (_d = opts === null || opts === void 0 ? void 0 : opts.startKey) !== null && _d !== void 0 ? _d : ((opts === null || opts === void 0 ? void 0 : opts.fromSortKey) &&
        rk &&
        Object.assign({}, (_b = {}, _b[hk] = hkv, _b), (_c = {}, _c[rk] = opts.fromSortKey, _c)));
    var filterExpression = (opts === null || opts === void 0 ? void 0 : opts.filterExpression)
        ? (0, conditions_1.serializeConditionExpression)(opts.filterExpression, attributes)
        : undefined;
    return dynamo
        .query({
        TableName: table,
        Limit: opts === null || opts === void 0 ? void 0 : opts.pageSize,
        IndexName: indexName,
        KeyConditionExpression: keyExpression,
        ExpressionAttributeNames: attributes.names,
        ExpressionAttributeValues: attributes.values,
        ExclusiveStartKey: lastKey && marshaller.marshallItem(lastKey),
        ScanIndexForward: !(opts && opts.descending),
        FilterExpression: filterExpression,
    })
        .then(function (r) {
        var _a;
        var nextStartKey = !!r.LastEvaluatedKey && !!rk
            ? marshaller.unmarshallItem(r.LastEvaluatedKey)
            : undefined;
        return {
            records: r.Items
                ? (_a = r.Items) === null || _a === void 0 ? void 0 : _a.map(marshaller.unmarshallItem.bind(marshaller))
                : [],
            lastSortKey: nextStartKey === null || nextStartKey === void 0 ? void 0 : nextStartKey[rk],
            nextStartKey: nextStartKey,
        };
    })
        .catch(function (e) {
        logger.error(e);
        return Promise.reject(e);
    });
}; };
var scan = function (dynamo, logger, table, hk, rk, marshaller, indexName) { return function (opts) {
    var _a, _b;
    var _c;
    var attributes = new dynamodb_expressions_1.ExpressionAttributes();
    var lastKey = (_c = opts === null || opts === void 0 ? void 0 : opts.startKey) !== null && _c !== void 0 ? _c : ((opts === null || opts === void 0 ? void 0 : opts.fromSortKey) &&
        rk &&
        Object.assign({}, (_a = {}, _a[hk] = opts.fromHashKey, _a), (_b = {}, _b[rk] = opts.fromSortKey, _b)));
    var filterExpression = (opts === null || opts === void 0 ? void 0 : opts.filterExpression)
        ? (0, conditions_1.serializeConditionExpression)(opts.filterExpression, attributes)
        : undefined;
    return dynamo
        .scan({
        TableName: table,
        Limit: opts === null || opts === void 0 ? void 0 : opts.pageSize,
        IndexName: indexName,
        ExpressionAttributeNames: Object.keys(attributes.names).length > 0 ? attributes.names : undefined,
        ExpressionAttributeValues: Object.keys(attributes.values).length > 0
            ? attributes.values
            : undefined,
        ExclusiveStartKey: lastKey && marshaller.marshallItem(lastKey),
        FilterExpression: filterExpression,
    })
        .then(function (r) {
        var _a;
        var nextStartKey = !!r.LastEvaluatedKey && !!rk
            ? marshaller.unmarshallItem(r.LastEvaluatedKey)
            : undefined;
        return {
            records: r.Items
                ? (_a = r.Items) === null || _a === void 0 ? void 0 : _a.map(marshaller.unmarshallItem.bind(marshaller))
                : [],
            lastHashKey: r.LastEvaluatedKey &&
                marshaller.unmarshallItem(r.LastEvaluatedKey)[hk],
            lastSortKey: nextStartKey === null || nextStartKey === void 0 ? void 0 : nextStartKey[rk],
            nextStartKey: nextStartKey,
        };
    })
        .catch(function (e) {
        logger.error(e);
        return Promise.reject(e);
    });
}; };
/**
 *
 * @param table The name of the DynamoDB table
 * @param config The dynamoDb and marshalling { @link Config }
 * @param client An optional implementation of the { @link DynamoDb } client
 */
// prettier-ignoreclie
var Table = function (tableDefintion, config) {
    var logger = (config === null || config === void 0 ? void 0 : config.logger) || console;
    var dynamo = (config === null || config === void 0 ? void 0 : config.client) || new client_dynamodb_1.DynamoDB(config || {});
    var tableName = tableDefintion.name, hashKey = tableDefintion.partitionKey, sortKey = tableDefintion.sortKey, indexes = tableDefintion.indexes;
    var createTable = function (props) { return __awaiter(void 0, void 0, void 0, function () {
        var _props, lsis, gsis, request;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _props = props;
                    lsis = Object.entries(tableDefintion.indexes).filter(function (k) { return k[1].indexType === 'local'; });
                    gsis = Object.entries(tableDefintion.indexes).filter(function (k) { return k[1].indexType === 'global'; });
                    request = {
                        TableName: tableName,
                        BillingMode: _props.billingMode,
                        ProvisionedThroughput: _props.provisionedThroughput && {
                            ReadCapacityUnits: _props.provisionedThroughput.read,
                            WriteCapacityUnits: _props.provisionedThroughput.write,
                        },
                        AttributeDefinitions: Object.entries(props.keyDefinitions).map(function (_a) {
                            var _b = __read(_a, 2), name = _b[0], type = _b[1];
                            return ({
                                AttributeName: name,
                                AttributeType: type,
                            });
                        }),
                        KeySchema: __spreadArray([
                            {
                                AttributeName: hashKey,
                                KeyType: 'HASH',
                            }
                        ], __read((sortKey
                            ? [
                                {
                                    AttributeName: sortKey,
                                    KeyType: 'RANGE',
                                },
                            ]
                            : [])), false),
                        LocalSecondaryIndexes: lsis.length === 0
                            ? undefined
                            : lsis.map(function (_a) {
                                var _b = __read(_a, 2), name = _b[0], sk = _b[1].sortKey;
                                return ({
                                    IndexName: name,
                                    KeySchema: [
                                        {
                                            AttributeName: hashKey,
                                            KeyType: 'HASH',
                                        },
                                        {
                                            AttributeName: sk,
                                            KeyType: 'RANGE',
                                        },
                                    ],
                                    Projection: {
                                        ProjectionType: 'ALL',
                                    },
                                });
                            }),
                        GlobalSecondaryIndexes: gsis.length === 0
                            ? undefined
                            : gsis.map(function (_a) {
                                var _b, _c, _d, _e, _f, _g;
                                var _h = __read(_a, 2), name = _h[0], _j = _h[1], pk = _j.partitionKey, sk = _j.sortKey;
                                return ({
                                    IndexName: name,
                                    ProvisionedThroughput: ((_c = (_b = _props.indexDefinitions) === null || _b === void 0 ? void 0 : _b[name]) === null || _c === void 0 ? void 0 : _c.provisionedThroughput) && {
                                        ReadCapacityUnits: (_e = (_d = _props.indexDefinitions) === null || _d === void 0 ? void 0 : _d[name]) === null || _e === void 0 ? void 0 : _e.provisionedThroughput.read,
                                        WriteCapacityUnits: (_g = (_f = _props.indexDefinitions) === null || _f === void 0 ? void 0 : _f[name]) === null || _g === void 0 ? void 0 : _g.provisionedThroughput.write,
                                    },
                                    KeySchema: [
                                        {
                                            AttributeName: pk,
                                            KeyType: 'HASH',
                                        },
                                        {
                                            AttributeName: sk,
                                            KeyType: 'RANGE',
                                        },
                                    ],
                                    Projection: {
                                        ProjectionType: 'ALL',
                                    },
                                });
                            }),
                    };
                    return [4 /*yield*/, dynamo.createTable(request).catch(function (e) {
                            console.error(e);
                            return Promise.reject(e);
                        })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); };
    var deleteTable = function () {
        return dynamo.deleteTable({ TableName: tableName }).then(function () { return void 0; });
    };
    var get = function (hkv, opts) { return __awaiter(void 0, void 0, void 0, function () {
        var keys, keysSupplied, projectionExpressionAttributes, projectionExpression, req;
        return __generator(this, function (_a) {
            keys = ((opts === null || opts === void 0 ? void 0 : opts.keys) || []);
            keysSupplied = keys.length > 0;
            projectionExpressionAttributes = new dynamodb_expressions_1.ExpressionAttributes();
            projectionExpression = keys
                .map(function (k) {
                var exp = projectionExpressionAttributes.addName(new dynamodb_expressions_1.AttributePath(k));
                return exp;
            })
                .join(', ');
            req = {
                TableName: tableDefintion.name,
                Key: marshalling_1.marshaller.marshallItem(extractKey(hkv, tableDefintion.partitionKey, sortKey)),
                ConsistentRead: opts === null || opts === void 0 ? void 0 : opts.consistentRead,
                ProjectionExpression: keysSupplied ? projectionExpression : undefined,
                ExpressionAttributeNames: keysSupplied
                    ? projectionExpressionAttributes.names
                    : undefined,
            };
            return [2 /*return*/, dynamo
                    .getItem(req)
                    .then(function (r) {
                    return r.Item
                        ? (opts === null || opts === void 0 ? void 0 : opts.marshaller)
                            ? (0, marshalling_1.unmarshall)(opts === null || opts === void 0 ? void 0 : opts.marshaller, r.Item)
                            : marshalling_1.marshaller.unmarshallItem(r.Item)
                        : null;
                })
                    .catch(function (e) {
                    logger.error(e);
                    return Promise.reject(e);
                })];
        });
    }); };
    var batchGet = function (keys, opts) {
        var _a;
        var projKeys = ((opts === null || opts === void 0 ? void 0 : opts.keys) || []);
        var projKeysSupplied = projKeys.length > 0;
        var projectionExpressionAttributes = new dynamodb_expressions_1.ExpressionAttributes();
        var projectionExpression = projKeys
            .map(function (k) {
            var exp = projectionExpressionAttributes.addName(new dynamodb_expressions_1.AttributePath(k));
            return exp;
        })
            .join(', ');
        return dynamo
            .batchGetItem({
            RequestItems: (_a = {},
                _a[tableName] = {
                    Keys: keys.map(function (hkv) {
                        return marshalling_1.marshaller.marshallItem(extractKey(hkv, hashKey, sortKey));
                    }),
                    ConsistentRead: opts === null || opts === void 0 ? void 0 : opts.consistentRead,
                    ProjectionExpression: projKeysSupplied
                        ? projectionExpression
                        : undefined,
                    ExpressionAttributeNames: projKeysSupplied
                        ? projectionExpressionAttributes.names
                        : undefined,
                },
                _a),
        })
            .then(function (r) {
            var _a;
            return Object.values((_a = r.Responses) !== null && _a !== void 0 ? _a : {})[0].map(marshalling_1.marshaller.unmarshallItem.bind(marshalling_1.marshaller));
        })
            .catch(function (e) {
            logger.error(e);
            return Promise.reject(e);
        });
    };
    var put = function (a, opts) {
        var attributes = new dynamodb_expressions_1.ExpressionAttributes();
        var ce = opts === null || opts === void 0 ? void 0 : opts.conditionExpression;
        var conditionExpression = ce !== undefined
            ? (0, conditions_1.serializeConditionExpression)(ce, attributes)
            : undefined;
        return dynamo
            .putItem({
            TableName: tableName,
            Item: marshalling_1.marshaller.marshallItem(a),
            ExpressionAttributeNames: Object.keys(attributes.names).length > 0
                ? attributes.names
                : undefined,
            ExpressionAttributeValues: Object.keys(attributes.values).length > 0
                ? attributes.values
                : undefined,
            ConditionExpression: conditionExpression,
        })
            .then(function (i) {
            return i.Attributes
                ? marshalling_1.marshaller.unmarshallItem(i.Attributes)
                : undefined;
        })
            .catch(function (e) {
            logger.error(e);
            return Promise.reject(e);
        });
    };
    var transactGet = function (keys) {
        return dynamo
            .transactGetItems({
            TransactItems: keys.map(function (k) { return ({
                Get: {
                    Key: marshalling_1.marshaller.marshallItem(extractKey(k, hashKey, sortKey)),
                    TableName: tableName,
                },
            }); }),
        })
            .then(function (r) {
            var _a;
            return ((_a = r.Responses) === null || _a === void 0 ? void 0 : _a.map(function (r) {
                return r.Item ? marshalling_1.marshaller.unmarshallItem(r.Item) : undefined;
            }).filter(function (i) { return i != undefined; })) || [];
        })
            .catch(function (e) {
            logger.error(e);
            return Promise.reject(e);
        });
    };
    var set = function (k, v, opts) {
        var request = serializeSetAction(v);
        var attributes = new dynamodb_expressions_1.ExpressionAttributes();
        var expression = request.serialize(attributes);
        var key = marshalling_1.marshaller.marshallItem(extractKey(k, hashKey, sortKey));
        var conditionExpression = (opts === null || opts === void 0 ? void 0 : opts.conditionExpression)
            ? (0, conditions_1.serializeConditionExpression)(opts.conditionExpression, attributes)
            : undefined;
        return dynamo
            .updateItem({
            TableName: tableName,
            Key: key,
            UpdateExpression: expression,
            ExpressionAttributeNames: Object.keys(attributes.names).length > 0
                ? attributes.names
                : undefined,
            ExpressionAttributeValues: Object.keys(attributes.values).length > 0
                ? attributes.values
                : undefined,
            ReturnValues: (opts === null || opts === void 0 ? void 0 : opts.returnValue) || 'ALL_NEW',
            ConditionExpression: conditionExpression,
        })
            .then(function (i) {
            return i.Attributes
                ? marshalling_1.marshaller.unmarshallItem(i.Attributes)
                : undefined;
        })
            .catch(function (e) {
            logger.error(e);
            return Promise.reject(e);
        });
    };
    var batchPut = function (a) {
        var _a;
        return dynamo
            .batchWriteItem({
            RequestItems: (_a = {},
                _a[tableName] = a.map(function (item) { return ({
                    PutRequest: {
                        Item: marshalling_1.marshaller.marshallItem(item),
                    },
                }); }),
                _a),
        })
            .then(function () { return void 0; })
            .catch(function (e) {
            logger.error(e);
            return Promise.reject(e);
        });
    };
    var batchDelete = function (a) {
        var _a;
        return dynamo
            .batchWriteItem({
            RequestItems: (_a = {},
                _a[tableName] = a.map(function (item) { return ({
                    DeleteRequest: {
                        Key: marshalling_1.marshaller.marshallItem(extractKey(item, hashKey, sortKey)),
                    },
                }); }),
                _a),
        })
            .then(function () { return void 0; })
            .catch(function (e) {
            logger.error(e);
            return Promise.reject(e);
        });
    };
    var transactWrite = function (args) {
        var deletes = (args.deletes || []).map(function (item) {
            var attributes = new dynamodb_expressions_1.ExpressionAttributes();
            var ce = item.conditionExpression;
            var conditionExpression = ce !== undefined
                ? (0, conditions_1.serializeConditionExpression)(ce, attributes)
                : undefined;
            return {
                Delete: {
                    TableName: tableName,
                    Key: marshalling_1.marshaller.marshallItem(extractKey(item.item, hashKey, sortKey)),
                    ConditionExpression: conditionExpression,
                    ExpressionAttributeNames: Object.keys(attributes.names).length > 0
                        ? attributes.names
                        : undefined,
                    ExpressionAttributeValues: Object.keys(attributes.values).length > 0
                        ? attributes.values
                        : undefined,
                },
            };
        });
        var puts = (args.puts || []).map(function (item) {
            var attributes = new dynamodb_expressions_1.ExpressionAttributes();
            var ce = item.conditionExpression;
            var conditionExpression = ce !== undefined
                ? (0, conditions_1.serializeConditionExpression)(ce, attributes)
                : undefined;
            return {
                Put: {
                    TableName: tableName,
                    Item: marshalling_1.marshaller.marshallItem(item.item),
                    ConditionExpression: conditionExpression,
                    ExpressionAttributeNames: Object.keys(attributes.names).length > 0
                        ? attributes.names
                        : undefined,
                    ExpressionAttributeValues: Object.keys(attributes.values).length > 0
                        ? attributes.values
                        : undefined,
                },
            };
        });
        var updates = (args.updates || []).map(function (u) {
            var request = serializeSetAction(u.updates);
            var attributes = new dynamodb_expressions_1.ExpressionAttributes();
            var expression = request.serialize(attributes);
            var key = marshalling_1.marshaller.marshallItem(extractKey(u.key, hashKey, sortKey));
            var ce = u.conditionExpression;
            var conditionExpression = ce !== undefined
                ? (0, conditions_1.serializeConditionExpression)(ce, attributes)
                : undefined;
            return {
                Update: {
                    Key: key,
                    UpdateExpression: expression,
                    ExpressionAttributeNames: Object.keys(attributes.names).length > 0
                        ? attributes.names
                        : undefined,
                    ExpressionAttributeValues: Object.keys(attributes.values).length > 0
                        ? attributes.values
                        : undefined,
                    ConditionExpression: conditionExpression,
                    TableName: tableName,
                },
            };
        });
        var TransactItems = __spreadArray(__spreadArray(__spreadArray([], __read(deletes), false), __read(puts), false), __read(updates), false);
        return dynamo
            .transactWriteItems({
            TransactItems: TransactItems,
        })
            .then(function () { return void 0; })
            .catch(function (e) {
            logger.error(e);
            return Promise.reject(e);
        });
    };
    var _delete = function (k, opts) {
        var attributes = new dynamodb_expressions_1.ExpressionAttributes();
        var ce = opts === null || opts === void 0 ? void 0 : opts.conditionExpression;
        var conditionExpression = ce !== undefined
            ? (0, conditions_1.serializeConditionExpression)(ce, attributes)
            : undefined;
        return dynamo
            .deleteItem({
            TableName: tableName,
            Key: marshalling_1.marshaller.marshallItem(extractKey(k, hashKey, sortKey)),
            ConditionExpression: conditionExpression,
            ExpressionAttributeNames: Object.keys(attributes.names).length > 0
                ? attributes.names
                : undefined,
            ExpressionAttributeValues: Object.keys(attributes.values).length > 0
                ? attributes.values
                : undefined,
        })
            .then(function () { return void 0; })
            .catch(function (e) {
            logger.error(e);
            return Promise.reject(e);
        });
    };
    var _indexes = Object.keys(indexes).reduce(function (p, k) {
        var _a;
        return (__assign(__assign({}, p), (_a = {},
            _a[k] = {
                query: query(dynamo, logger, tableName, indexes[k].partitionKey, indexes[k].sortKey, marshalling_1.marshaller, indexes[k].name),
                scan: scan(dynamo, logger, tableName, indexes[k].partitionKey, indexes[k].sortKey, marshalling_1.marshaller, indexes[k].name),
            },
            _a)));
    }, {});
    var _query = query(dynamo, logger, tableName, hashKey, sortKey, marshalling_1.marshaller);
    // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
    var _scan = scan(dynamo, logger, tableName, hashKey, sortKey, marshalling_1.marshaller);
    var transactPut = function (a) { return transactWrite({ puts: a }); };
    var transactDelete = function (a) { return transactWrite({ deletes: a }); };
    var retval = {
        createTable: createTable,
        deleteTable: deleteTable,
        get: get,
        batchGet: batchGet,
        transactGet: transactGet,
        query: _query,
        scan: _scan,
        put: put,
        set: set,
        batchPut: batchPut,
        batchDelete: batchDelete,
        transactPut: transactPut,
        transactDelete: transactDelete,
        transactWrite: transactWrite,
        delete: _delete,
        indexes: _indexes,
    };
    return retval;
};
exports.Table = Table;
